%Macro QTest;
   %local test two text;
   %let test=%NRSTR(One &two and three.);
   %let two=The wrong text;

   /* Extract and print the second word, macro references inadvertently resolve */
   %let text=%scan(&test,2,%str( ));
   %PUT NOTE: Resolved with SCAN: &text;

   /* Extract and print the second word, without resolving macro references */
   %let text=%qscan(&test,2,%str( ));
   %PUT NOTE: Resolved with QSCAN: &text;
%mend;

%Qtest

%macro QTest2;
   %local d t;
   %LET T=%STR( oops - my bad!);
   %LET customer=%nrstr(Our valued customer AT&T);
   %PUT NOTE: Text was STORED ok: "&customer";
   %PUT NOTE: SCAN says this customer is %scan(&customer,-1,%STR( ));
   %PUT NOTE: QSCAN says this customer is %qscan(&customer,-1,%STR( ));
%mend;

%macro QTest2;
Data _null_;
   call symput('t',' oops - my bad!');
   call symputx('customer','Our valued customer CS&T','L');
run;
%PUT NOTE: The text is "&customer";
%PUT NOTE: SUPERQ says the text is "%superq(customer)";
%PUT;

%PUT NOTE: SCAN says this customer is %scan(&customer,-1,%STR( ));
%PUT NOTE: QSCAN says this customer is %qscan(&customer,-1,%STR( ));
%PUT;

%PUT NOTE: SCAN (with BQUOTE) says this customer is %scan(%BQUOTE(&customer),-1,%STR( ));
%PUT NOTE: QSCAN (with NRBQUOTE) says this customer is %qscan(%NRBQUOTE(&customer),-1,%STR( ));
%PUT;

%PUT NOTE: SCAN (with SUPERQ) says this customer is %scan(%SUPERQ(customer),-1,%STR( ));
%PUT NOTE: QSCAN (with SUPERQ) says this customer is %qscan(%SUPERQ(customer),-1,%STR( ));
%PUT;
%mend;
%QTest2

%macro FindExcelFilesIn(dir);
  /***********************************************************
   This macro looks up the members of of a directory and 
   determines if it is an Excel file
  ***********************************************************/
   %local fileref rc did dnum dmem memname didc ext;
   %if &dir= %then %do;
      %put ERROR: (FindExcelFilesIn) Please specify a directory.;
      %GoTo EndMacro;
   %end;
   /* Use SUPERQ here because path may include special characters */
   %let rc=%sysfunc(filename(fileref,%superq(dir)));
   %let did=%sysfunc(dopen(&fileref));
   %if &did=0 %then %do;
      %put ERROR: (FindExcelFilesIn) Directory "&dir" does not exist;
      %GoTo EndMacro;
   %end;
   %let dnum=%sysfunc(dnum(&did));
   %PUT NOTE: (FindExcelFilesIn) Examining &DNUM items in directory "&dir".;
   %do dmem=1 %to &dnum;
   /* QSYSFUNC is needed here, because file names may include special characters */
      %let nextfile=%Qsysfunc(dread(&did,&dmem));
   /* QUPCASE and QSCAN needed here - file extension may include special characters */
      %let ext=%qupcase(%qscan(&nextfile,-1,.)); 
      %if &Ext = XLS OR &Ext=XLSX %then
         %do;
         %put NOTE-  File#&Dmem (&NextFile) is an Excel file.;
         %end;
      %else %do;
         %put ERROR- File#&Dmem (&NextFile) is not an Excel file.;
      %end;
   %end;
   %let didc=%sysfunc(dclose(&did));
   %let rc=%sysfunc(filename(fileref));
   %EndMacro:
%mend;
 
%FindExcelFilesIn(%str(C:\Users\&sysuserid\Desktop\blogs\Q functions))
